<?php

class actionUcartAddCart extends cmsAction {

    public function run(){

        if (!$this->request->isAjax()){ cmsCore::error404(); }
		
        $error = false;

		$user = cmsUser::getInstance();
		
		$item_id = $this->request->get('item_id');
		$ctype_id = $this->request->get('ctype_id');
		$ctype_name = $this->request->get('ctype_name');
		$count = $this->request->get('count');
		$props = $this->request->get('props');

		if(!is_numeric($count) || $count<1 || $count>1000000){
			$count = 1;
		} else {
			$count = ceil($count);
		}

		if(!$ctype_id) {
			$cm = cmsCore::getModel('content');
			$ctype = $cm->getContentTypeByName($ctype_name);
			$ctype_id = $ctype['id'];
		}

		if(!empty($props)) {
			$this->model->filterEqual('props', cmsModel::arrayToYaml($props));
		}

		$item_cart_exist = $this->model->getItemCart($ctype_id, $item_id, $user->id);
		if ($item_cart_exist) {
			$this->model->addCartCount($item_cart_exist['id'], $count);
		} else {
			$this->model->addCart($ctype_id, $item_id, $user->id, $count, $props);
		}
		
		$template = cmsTemplate::getInstance();
        $template->renderJSON(array(
            'error' => $error
        ));

    }

}
