<?php

class actionUcartOrderEdit extends cmsAction {

    public function run($id){
		
		$errors = false;
		
		$form = $this->getForm('order');
		
		$is_submitted = $this->request->has('submit');
		
		$item = $this->model->getOrderById($id);
        
		if ($is_submitted){
			
            $item = $form->parse($this->request, $is_submitted);
			
			$errors = $form->validate($this, $item);
			
			if (!$errors){
				
				$this->model->updateOrder($id, $item);

				$back = $this->request->get('back');
				
				if($back)
					$this->redirect($back);
            	else
					$this->redirectToAction('order');
				
			}
			
			if ($errors){
				
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
				
			}
        
		}
		
        return cmsTemplate::getInstance()->render('backend/order_edit', array(
            'form' => $form,
			'errors' => $errors,
			'item' => $item
        ));

    }

}
