<?php

class actionUcartStatusEdit extends cmsAction {

    public function run($id){
		
		$errors = false;
		
		$form = $this->getForm('status');
		
		$is_submitted = $this->request->has('submit');
		
		$item = $this->model->getStatus($id);
        
		if ($is_submitted){
			
            $item = $form->parse($this->request, $is_submitted);
			
			$errors = $form->validate($this, $item);
			
			if (!$errors){
				
				$this->model->updateStatus($id, $item);
            
				$this->redirectToAction('status');
				
			}
			
			if ($errors){
				
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
				
			}
        
		}
		
        return cmsTemplate::getInstance()->render('backend/status_edit', array(
            'form' => $form,
			'errors' => $errors,
			'item' => $item
        ));

    }

}
