<?php

class formUcartOptions extends cmsForm {

	public $is_tabbed = true;
	
	public function init(){

		$user = cmsUser::getInstance();
		
		$options = array(
		
			array(
				'type' => 'fieldset',
				'title' => 'Общие настройки',
				'childs' => array(

					new fieldString('curr', array(
                        'title' => 'Валюта',
                        'default' => 'рубль|рубля|рублей',
						'hint' => 'В формате: один|два|десять. Например рубль|рубля|рублей',
                    )),
					
					new fieldString('val', array(
                        'title' => 'Сокращенное обозначение валюты',
                        'default' => 'руб.',
						'hint' => 'Например: руб.',
                    )),

                    new fieldHtml('no_bin_text', array(
                        'title' => 'Текст в пустой корзине',
                        'default' => 'У вас в корзине пусто',
                        'rules' => array(
                            array('required')
                        ),
                        'options' => array(
							'editor' => 'markitup',
						),
                    )),

                    new fieldHtml('order_success', array(
						'title' => 'Текст на странице успешно созданного заказа',
						'options' => array(
							'editor' => 'markitup',
						),
					)),

					new fieldHtml('order_item_after', array(
						'title' => 'Текст на странице заказа после его содержания',
						'options' => array(
							'editor' => 'markitup',
						),
					)),

					new fieldString('bin_selector', array(
                        'title' => 'Селектор блока для корзины',
                        'default' => '#controller_wrap',
						'hint' => 'Не изменяйте, если не знаете что это',
                    )),

					new fieldCheckbox('admin_menu', array(
						'title' => 'Показывать UCart в главном меню Панели управления',
					)),
					
				)
				
			),

			array(
				'type' => 'fieldset',
				'title' => 'Оформление заказа',
				'childs' => array(

					new fieldString('required_text', array(
                        'title' => 'Добавить чекбокс "Согласие с правилами". Введите текст поля.',
                        'default' => 'С правилами покупки товаров согласен',
						'hint' => 'Не заполняйте это поле, если вам не нужны подтверждения',
                    )),

                    new fieldString('required_link', array(
                        'title' => 'Ссылка для чекбокса "Согласие с правилами"',
						'hint' => 'Не заполняйте это поле, если ссылка на документ не нужна',
                    )),

					new fieldHtml('order_before_form', array(
						'title' => 'Текст на странице оформления заказа',
						'hint' => 'Произвольный текст, например "о вариантах и способах оплаты"<br />Текст размещается между списком товаров в корзине и формой заказа."',
						'options' => array(
							'editor' => 'markitup',
						),
					)),
					
				)
				
			),

			array(
				'type' => 'fieldset',
				'title' => 'Уведомления',
				'childs' => array(

					new fieldString('email_notify', array(
                        'title' => 'Email для оповещения о новых заказах',
                        'default' => $user->email,
						'hint' => 'Можно указать несколько адресов, через запятую',
                    )),

                    new fieldString('id_notify', array(
                        'title' => 'ID пользователя для оповещения о новых заказах на сайте',
                        'default' => $user->id,
						'hint' => 'Можно указать несколько id, через запятую',
                    )),
					
				)
				
			),
			
		);

		$userpartner = cmsCore::isControllerExists('userpartner') ? cmsCore::getController('userpartner') : false;
        if ($userpartner) {
           	$options[] = array(
				'type' => 'fieldset',
				'title' => 'Партнерская программа',
				'childs' => array(
						
					new fieldCheckbox('userpartner_on', array(
						'title' => 'Включить начисления по партнерской программе',
					)),
						
				)
			);
        }

		return $options;
	
	}
	
}
