<?php

class formUcartRatio extends cmsForm {
	
	public function init($options=false){

		$cats_list = array();

		if (!empty($options['ctype_id'])){

			$content_model = cmsCore::getModel('content');
			$ctype = $content_model->getContentType($options['ctype_id']);
			$cats = $content_model->getCategoriesTree($ctype['name']);

			if ($cats){
				foreach($cats as $cat){
					if ($cat['ns_level'] > 1){
						$cat['title'] = str_repeat('-', $cat['ns_level']) . ' ' . $cat['title'];
					}
					$cats_list[$cat['id']] = $cat['title'];
				}
			}

		}
		
		return array(
		
			array(
				'type' => 'fieldset',
				'childs' => array(
					
					new fieldString('title', array(
                        'title' => 'Название коэффициента',
						'rules' => array(
							array('required')
                        ),
                    )),

                    new fieldList('ctype_id', array(
                        'title' => 'Тип контента товара',
                        'hint' => 'Настройка игнорируется, если выбран тип коэффициента по заказу',
                        'generator' => function($item) {
                            $model = cmsCore::getModel('content');
                            $tree = $model->getContentTypes();
                            $items = array();
                            if ($tree) {
                                foreach ($tree as $item) {
                                    $items[$item['id']] = $item['title'];
                                }
                            }
                            return $items;
                        },
                    )),

                    new fieldList('category_id', array(
						'title' => 'Фильтр по категории товара',
						'hint' => 'Настройка игнорируется, если выбран тип коэффициента по заказу',
						'parent' => array(
							'list' => 'ctype_id',
							'url' => href_to('content', 'widget_cats_ajax')
						),
						'items' => $cats_list
					)),

                    new fieldList('type', array(
                        'title' => 'Тип',
						'items' => array(
							1 => 'На товар',
							2 => 'На заказ'
						) 
                    )),

                    new fieldList('unit', array(
                        'title' => 'Единицы',
						'items' => array(
							1 => 'Проценты',
							2 => 'Сумма'
						) 
                    )),

                    new fieldNumber('value', array(
                        'title' => 'Значение',
						'rules' => array(
							array('required')
                        ),
                    )),

                    new fieldNumber('min_amount', array(
                        'title' => 'Минимальная сумма заказа для активации коэффициента',
                        'hint' => 'Применимо для коэффициентов "на весь заказ"',
                    )),

                    new fieldNumber('max_amount', array(
                        'title' => 'Максимальная сумма заказа для активации коэффициента',
                        'hint' => 'Применимо для коэффициентов "на весь заказ"',
                    )),
					
					new fieldText('description', array(
                        'title' => 'Информация о коэффициенте'
                    )),

                    new fieldString('name', array(
                        'title' => 'Системное имя',
                        'hint' => 'Не обязательное поле'
                    )),
					
				)
				
			),
			
		);
		
	}
	
}
