<?php

class fieldUcart extends cmsFormField {

    public $title       = 'Корзина';
	public $sql			= 'TINYINT(1) UNSIGNED NULL DEFAULT 1';
    public $filter_type = false;
	public $allow_index = true;

	public function getOptions(){

        return array(
	
				new fieldList('tpl_in_list', array(
                        'title' => 'Шаблон в списке записей',
                        'default' => 'ucart_list',
                        'generator' => function($item) {
                            $tpls = cmsCore::getFilesList('templates/'.cmsTemplate::getInstance()->name.'/controllers/ucart/fields','ucart_*');
                            $items = array();
                            if ($tpls) {
                                foreach ($tpls as $tpl) {
									if(!mb_strstr($tpl, 'ucart_')){ continue; }
                                    $name = str_replace('.tpl.php','',$tpl);
                                    $items[$name] = $name;
                                }
                            }
                            return $items;
                        }
                    )),					
				
				new fieldList('tpl_in_item', array(
                        'title' => 'Шаблон на странице записи',
                        'default' => 'ucart_item',
                        'generator' => function($item) {
                            $tpls = cmsCore::getFilesList('templates/'.cmsTemplate::getInstance()->name.'/controllers/ucart/fields','ucart_*');
                            $items = array();
                            if ($tpls) {
                                foreach ($tpls as $tpl) {									
									if(!mb_strstr($tpl, 'ucart_')){ continue; }
									$name = str_replace('.tpl.php','',$tpl);
                                    $items[$name] = $name;
                                }
                            }
                            return $items;
                        }
                    )),	
				
				
            new fieldString('before_count', array(
                'title'   => 'Текст перед полем для ввода кол-ва товара',
                'default' => 'Кол-во'
            )),
            new fieldCheckbox('show_count', array(
                'title'   => 'Показывать ввод количества товара',
                'default' => 1
            )),
            new fieldString('btn', array(
                'title'   => 'Текст на кнопке',
                'default' => 'В корзину'
            )),
            new fieldString('btn_active', array(
                'title'   => 'Текст на кнопке после нажатия',
                'default' => 'Добавлено'
            )),
        );

    }
	
	public function parseTeaser($value){

		if(empty($this->item['id']) || empty($this->item['price']))
			return '';

		$ucart = cmsCore::getController('ucart');
		$ucart->saveBinId();

		$template = cmsTemplate::getInstance();
		$template->addControllerCSS('styles', 'ucart');
		$template->addControllerJS('script', 'ucart');
		$template->addJS('templates/default/js/jquery-ui.js');

		$item = $this->item;
		$ctype = $this->item['ctype'];
		
		$btn_id = 'bin_'.$ctype['name'].'_'.$item['id'];
		
		$is_count = $this->getOption('show_count', false);
		$btn = $this->getOption('btn','');
		$btn_active = $this->getOption('btn_active','');
		$tpl = $this->getOption('tpl_in_list');

						
		$tpl_file = $template->getTemplateFileName('controllers/ucart/fields/'.$tpl);
        ob_start();
        include($tpl_file);
        $html = ob_get_clean();
		return $html;				

    }	
	
	public function parse($value){

		if(empty($this->item['id']) || empty($this->item['price']))
			return '';

		$ucart = cmsCore::getController('ucart');
		$ucart->saveBinId();

		$template = cmsTemplate::getInstance();
		$template->addControllerCSS('styles', 'ucart');
		$template->addControllerJS('script', 'ucart');
		$template->addJS('templates/default/js/jquery-ui.js');
		
		$item = $this->item;
		$ctype = cmsCore::getModel('content')->getContentTypeByName($this->item['ctype_name']);
		
		$btn_id = 'bin_'.$ctype['name'].'_'.$item['id'];
		
		$is_count = $this->getOption('show_count', false);
		$btn = $this->getOption('btn','');
		$btn_active = $this->getOption('btn_active','');
		$tpl = $this->getOption('tpl_in_item');

						
		$tpl_file = $template->getTemplateFileName('controllers/ucart/fields/'.$tpl);
        ob_start();
        include($tpl_file);
        $html = ob_get_clean();
		return $html;				

    }
	
	

    public function getInput($value){
    	return '';
    }

    public function store($value, $is_submitted, $old_value=null){
        return 1;
    }

}
